//+------------------------------------------------------------------+
//|                                           Lock&&PipsingXR2.5.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "#Copyright  2008, XrustSolution.#"
#property link      "#http://www.xrust.ucoz.net#"
#include <stdlib.mqh>
//-------------------------------------------------------------------+
extern string a="KEY PARAMETERS OF THE ADVISER";
extern double    CG= 96;
extern int       MinPips=7;
extern bool      FullAuto=true;
extern string ha="the percentage of risk as% of deposit amount";
extern double    Risk=1;
extern string x="Permission to use the dynamic changes in the lot";
extern bool      Martin=false;
extern string gb="dynamic change lot factor. if <1 it increases lot , if > 1 it is lot decreases ";
extern double    MartinKoff=1;
extern string k="Trailing step on equity as% of the deposit";
extern double    EqwTralStep=0.03;
extern string ="minimum break between the opening of orders in minutes";
extern int       MinTradePause=5;
extern string m="Permission to restrict trade in time";
extern bool      TradeTime=false;
extern string n="Hour start of trading";
extern int       StartTrade=19;
extern string o="Hour late trade";
extern int       EndTrade=5;
extern string p="Permission to display information in the main window";
extern bool      ShowComment=true;
extern string r="switch alarm systems and security";
extern bool      MargineVarning=false;
extern string ss="switch emergency return";
extern bool      EmergencyReturn=false;
extern string rr="the percentage of the deposit for the emergency return";
extern double    EmergencyPersent=100;
extern string s="permission for drawing graphic elements";
extern bool      SetArrow=true;
extern string t="Key closing level position without loss";
extern bool      WithoutLoss=false;
int       TotalOrders=50;
//----Variables for KimIV funcions ---------------------------------+
bool NumberOfTry=3,UseSound=false,print=false;
string NameFileSound = "expert.wav";   //   
color  clOpenBuy     = Blue;           //    Buy
color  clOpenSell    = Red;            //    Sell
bool   MarketWatch=false;
bool   gbDisabled    = False;          // 
int BuyMagic1=2891;
int SellMagic1=73351;
static int PrevTime=0;double Lot;
double MinLot, MaxLot, MarginMinLot;   
int    MinLotDgts,period,GrossPeriod,GrossTrand=0;
int       Slippage=3;static double prr;
//------------------------------------------------------------------+
static double StartDepo, gEqviti;
static double gPriseAp,gPriseDn,gMidPrise;
int gFrChSize,tP;
static bool asd=false;
int BuySell_1=0,BuySell_2=0,BuySell_3=0;
int gCountBuy_1=1,gCountSell_1=1;
double lot;
static string gTime;
static bool Expdis=false;
int MaxOrd_1;
bool eqvtrade,TradeOfTime;
double Sredstva;
double neiro[1000000][3];
double  stat[1000000][3];
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
void init()
  {
string Name=StringConcatenate("stat",Symbol(),Period());
string namebin=StringConcatenate(Name,".bin"); 
int count=GlobalVariableGet("count");
//ArrayResize(stat,count*3);
int handle9=FileOpen(namebin,FILE_BIN|FILE_READ);
if(handle9>=0){
  FileReadArray(handle9,neiro,0,count*3); 
  FileClose(handle9);
}else{Print("file",namebin," not found");} 
for(int i=0;i<1000000;i++){
int asd=neiro[i][0];
stat[asd][0]=neiro[i][0];
stat[asd][1]=neiro[i][1];
stat[asd][2]=neiro[i][2];
}
//-------------------------------------------------------------------+  
  //string neironame="neiro.bin";
  //int handle0=FileOpen(neironame,FILE_BIN|FILE_READ);
  //if(handle0>=0){
  //FileReadArray(handle0,neiro,0,200000); 
  //FileClose(handle0);
  //}
  MathSrand(TimeLocal());
  MaxOrd_1=TotalOrders;
  StartDepo = AccountBalance(); 
  if(GlobalVariableCheck("stop")){GlobalVariableDel("stop");}
  if(!GlobalVariableCheck("multi")){GlobalVariableSet("multi",1);}else{
    double set=GlobalVariableGet("multi");
    set++;
    GlobalVariableSet("multi",set);
  }
  if(!GlobalVariableCheck("Risc")){GlobalVariableSet("Risc",Risk);}else{
    Risk=GlobalVariableGet("Risc");
  }
  if(!GlobalVariableCheck("pause")){GlobalVariableSet("pause",MinTradePause);}else{
    MinTradePause=GlobalVariableGet("pause");
  }  
  if(!GlobalVariableCheck("disable")){GlobalVariableSet("disable",0);}
  if(GlobalVariableCheck("stop")){GlobalVariableDel("stop");}
  if(GlobalVariableGet("multi")>1){SetArrow=false;} 
   return;
  }
//+------------------------------------------------------------------+
void deinit(){
  if(GlobalVariableCheck("stop")){GlobalVariableDel("stop");}

  Comment("  ");
  if(GlobalVariableCheck("multi")){
  double set=GlobalVariableGet("multi");
    if(set>1){
      set--;
      GlobalVariableSet("multi",set);
    }else{
      GlobalVariableDel("multi");
      GlobalVariableDel("disable");
      if(GlobalVariableCheck("Risc")){
        GlobalVariableDel("Risc");
      GlobalVariableDel("sredstva");   
      GlobalVariableDel("pause");     
      }
    }
  }
  if(Expdis){
    double Exdis=GlobalVariableGet("disable");
    Exdis--;
    GlobalVariableSet("disable",Exdis);      
    Expdis=false;
  }
return(0);} //deinit                   |
//+------------------------------------------------------------------+
int start()
  {
  //if(CountOpOrd("0",1)==CountOpOrd("0",0)&&GrPorfit()>0){CloseAll();}
  if(CountOpOrd("0")<2){if(GrPorfit()>MinPips/CalcLotsAuto()/10){CloseAll();}}  
  if(GlobalVariableGet("multi")>1){SetArrow=false;TradeOfTime=false;}else{TradeOfTime=TradeTime;}//   
  if(gEqviti==0){gEqviti=AccountBalance();}// 
//                
    MaxOrd_1=TotalOrders;
    if(MargineVarning){
      if(MaxOrd_1>AccountBalance()/(MarketInfo(Symbol(),MODE_MARGINREQUIRED)*CalcLotsAuto()*2*(GlobalVariableGet("multi")-GlobalVariableGet("disable")))){
      MaxOrd_1=(AccountBalance()/(MarketInfo(Symbol(),MODE_MARGINREQUIRED)*CalcLotsAuto()*2*(GlobalVariableGet("multi")-GlobalVariableGet("disable"))));}
    }else{
      if(MaxOrd_1>AccountBalance()/(MarketInfo(Symbol(),MODE_MARGINREQUIRED)*CalcLotsAuto()*(GlobalVariableGet("multi")-GlobalVariableGet("disable")))){
      MaxOrd_1=(AccountBalance()/(MarketInfo(Symbol(),MODE_MARGINREQUIRED)*CalcLotsAuto()*(GlobalVariableGet("multi")-GlobalVariableGet("disable"))));}
    }  
//          
   if(OrdersTotal()<1){
     Sredstva=AccountFreeMargin();
     if(!GlobalVariableCheck("sredstva")){GlobalVariableSet("sredstva",Sredstva);}
     else{if(GlobalVariableGet("sredstva")!=Sredstva){GlobalVariableSet("sredstva",Sredstva);}}
   }
//         
   if((GlobalVariableGet("multi")-GlobalVariableGet("disable"))>2){TradeOfTime=false;}
//        
   if(MargineVarning){if(Varning()){Sleep(10000);return(0);}}
//         
   //if(!IsDemo()&&!IsOptimization()&&!IsTesting()){
     //if(AccountNumber()!=74777){
     //  Comment("Bad Account!!!");
     //  Sleep(500);
     //  Comment("  ");
     //  return(0);
     //}
   //}  
   eqvtrade=false; 
//          
  if(EmergencyReturn){
    if(AccountEquity()<=AccountBalance()/100*EmergencyPersent){
      CloseAll();
      double crash=GlobalVariableGet("disable");
      crash++;
      GlobalVariableSet("disable",crash);
      Expdis=true;
      Comment("System crashed! Restart!");
      Sleep(500);
      Comment("  ");
      return(0);           
    }
  }  
//        
  if(OrdersTotal()<1){
    if(GlobalVariableCheck("stop")){GlobalVariableDel("stop");}  
    gEqviti=AccountBalance(); 
  } 
// 
  if(EcvitiTral3(EqwTralStep)){
    return(0);}
  if(GlobalVariableCheck("stop")){return(0);}
//-----------------------------------------------------------------------------+
//                    |
//-----------------------------------------------------------------------------+
  if(GlobalVariableGet("multi")>1){
    if(MaxOrd_1<15){
      if(!GlobalVariableCheck("disable")){
        GlobalVariableSet("disable",1);
      }else{
        if(!Expdis){
          double dis=GlobalVariableGet("disable");
          dis++;
          GlobalVariableSet("disable",dis);
          Expdis=true;
        }  
      } 
      Comment("\nMulti Chart Mode \n",
              "STOPPED\n",
              "Because AccountFreeMargin is few"
               );
      return(0);        
    }
    if(MaxOrd_1>18){
      if(Expdis){
        double Exdis=GlobalVariableGet("disable");
        Exdis--;
        if(Exdis<=0){Exdis=0;}
        GlobalVariableSet("disable",Exdis);      
        Expdis=false;
      }  
    }
  }  
//----------------------------------------------------------------------------  
  BuySell_1=0;BuySell_2=0;BuySell_3=0;
  Info();  
  //DelLoss();
  CloseBy(); 
  MultyClose();
// -------------------------------------------------------------------------------------  
  if(!GlobalVariableCheck("stop")){
  if(NevBar()){
//-------------------------------------------------------------------------------  
       if(SetArrow){
         if(CountOpOrd("0")>0){
           SetArrow("NullProfitDot",4,1,0,NullDot(),White);
           ////SetArrow("NullDotBuy",4,1,0,NullDotBuy(),Blue);
           //SetArrow("NullDotSell",4,1,0,NullDotSell(),Red);
           
           //SetArrow("Buysell",4,1,0,(NullDot()-NullDotSell())/2+NullDotSell(),Yellow);
           //SetArrow("Sellbuy",4,1,0,(NullDotBuy()-NullDot())/2+NullDot(),Yellow);
         }       
       }
//--------------------------------------------------------------------------------       
    if(TradeTime()){
      if(Trade()>0){
        if(CountOpOrd("0")<MaxOrd_1&&TimeOfTrade()&&CalcLotsAuto()>0){
          lot=CalcLotsAuto();
          if(CountOpOrd("0")>2){if(Martin){lot=OrdersLot();}}
          if(!FullAuto){if(CountOpOrd("0")>=MaxOrd_1/10){lot=OrdersLot();}}
          if(CountOpOrd("0")<1){OpenPosition("",0,lot,0,0,BuyMagic1);}
          else{
            if(OutOfPrise()){
              if(PorfitBuySell(0)<PorfitBuySell(1)){OpenPosition("",1,lot,0,0,SellMagic1);}
              if(PorfitBuySell(0)>PorfitBuySell(1)){OpenPosition("",0,lot,0,0,BuyMagic1);}              
            }else{
              //if(!LastOrdOfDir())OpenPosition("",1,lot,0,0,SellMagic1);
              //if(LastOrdOfDir())OpenPosition("",0,lot,0,0,BuyMagic1); 
            }  
          }
        }
      }
      if(Trade()<0){
        if(CountOpOrd("0")<MaxOrd_1&&TimeOfTrade()&&CalcLotsAuto()>0){
          lot=CalcLotsAuto();
          if(CountOpOrd("0")>2){if(Martin){lot=OrdersLot();}}
          if(!FullAuto){if(CountOpOrd("0")>=MaxOrd_1/10){lot=OrdersLot();}}
          if(CountOpOrd("0")<1){OpenPosition("",1,lot,0,0,SellMagic1);}
          else{
            if(OutOfPrise()){
              if(PorfitBuySell(0)<PorfitBuySell(1)){OpenPosition("",1,lot,0,0,SellMagic1);}
              if(PorfitBuySell(0)>PorfitBuySell(1)){OpenPosition("",0,lot,0,0,BuyMagic1);}              
            }else{
              //if(LastOrdOfDir())OpenPosition("",0,lot,0,0,BuyMagic1);
              //if(!LastOrdOfDir())OpenPosition("",1,lot,0,0,SellMagic1); 
            }  
          }
        }
      }
//--------------------------------------------------------------------------------------------      
      lot=CalcLotsAuto();
    if(TimeOfTrade()){  
      if(!OutOfPrise()){
        if(Bid>NullDot()){
          //if(PriseCompare(Close[0],NullDot(),NullDotSell())){
          if((NullDotBuy()-NullDot())/2+NullDot()<Bid+2*Point&&(NullDotBuy()-NullDot())/2+NullDot()>Bid-2*Point){  
            OpenPosition("",1,lot,0,0,SellMagic1);
          }
        }
        if(Bid<NullDot()){
          //if(PriseCompare(Close[0],NullDot(),NullDotBuy())){
          if((NullDot()-NullDotSell())/2+NullDotSell()<Bid+2*Point&&(NullDot()-NullDotSell())/2+NullDotSell()>Bid-2*Point){  
            OpenPosition("",0,lot,0,0,BuyMagic1);
          }        
        }      
      }
    } 
//--------------------------------------------------------------------------------------------      
    }
  }
  }
//-------------------------------------------------------------------------------------------------------
   return(0);
  } 
int   MInProfit=0;
//+----------------------------------------------------------------------------+
//                                                         +
//-----------------------------------------------------------------------------+
bool PriseCompare(double Pr1,double Pr2,double Pr3,int Slipp=3){double prise1,prise2,prise3;
prise1=NormalizeDouble(Pr1,Digits);
Slipp=Slipp*Point;
if(Pr2>Pr3){prise2=NormalizeDouble(Pr2,Digits);prise3=NormalizeDouble(Pr3,Digits);}
if(Pr2<Pr3){prise2=NormalizeDouble(Pr3,Digits);prise3=NormalizeDouble(Pr2,Digits);}
//if(prise2==0||prise3==0)return(false);
if(prise1>((prise2-prise3)/2+prise2)+Slipp&&prise1<((prise2-prise3)/2+prise2)-Slipp){Print("Compare");return(true);}
return(false);
}
//+----------------------------------------------------------------------------+
//                +
//-----------------------------------------------------------------------------+
bool LastOrdOfDir(){int lasttime,lasttyp;double lastprise;
if(OrdersTotal()<2){return(true);}
  for(int n=0;n<OrdersTotal();n++){
    if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Symbol()){
        if(lasttime<OrderOpenTime()){
          lasttime=OrderOpenTime();
          lasttyp=OrderType();
          lastprise=OrderOpenPrice();
        }    
      }
    }
  }
  if(lasttyp<1)return(false);else return(true);
  //if(Bid>lastprise){return(true);}
  //if(Bid<lastprise){return(false);}  
}
//+----------------------------------------------------------------------------+
//                           +
//-----------------------------------------------------------------------------+
bool OutOfPrise(){double minprise=100000,maxprise=0;
if(OrdersTotal()<2){return(true);}
  for(int n=0;n<OrdersTotal();n++){
    if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Symbol()){
        if(minprise>OrderOpenPrice()){minprise=OrderOpenPrice();}
        if(maxprise<OrderOpenPrice()){maxprise=OrderOpenPrice();}
      }  
    }
  }
  if(Bid>minprise&&Bid<maxprise){return(false);}  
return(true);      
}
//---------------------------------------------------------
int Trade(){static int napr=0;  
//if(MathRand() < 32767/2){return(1);}else{return(-1);}
//return(0);
   double a=iCustom(Symbol(),0,"Center_of_Gravity",CG,0,12);
   double b=iCustom(Symbol(),0,"Center_of_Gravity",CG,0,0);
   //if(Close[1]>Open[0]){
   if(a>b){

return(-1);}
   //if(Close[1]<Open[0]){
   if(a<b){

return(1);}

return(0);
}    
//+----------------------------------------------------------------------------+
//                   +
//-----------------------------------------------------------------------------+
double GrPorfit(){double grpr=0;
   for(int n=0;n<OrdersTotal();n++){
     if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){  
       if(OrderSymbol()==Symbol()){
         grpr=grpr+OrderProfit()+OrderSwap()+OrderCommission();
       }  
     }    
   } 
return(grpr);
}  
//-----------------------------------------------------------------------------+
//                                |
//-----------------------------------------------------------------------------+
double OrdersLot(){int count=0;double Lt=0,lots=0;
double StepLot=MarketInfo(Symbol(),MODE_LOTSTEP);
if(StepLot==0.01){int step=2;}else{step=1;}
  for(int i=0;i<OrdersTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Symbol()){
        if(OrderCloseTime()==0){
          Lt=Lt+OrderLots();
          count++;
        }  
      }  
    }
  }
  lots=NormalizeDouble((Lt/(count*MartinKoff)),step);
  if(lots<=MarketInfo(Symbol(),MODE_MINLOT)){lots=MarketInfo(Symbol(),MODE_MINLOT);}
return(lots);
}  
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
double CalcLotsAuto(){double LotOpt,LotNeOpt,Zalog;
   RefreshRates();
   double bs=AccountBalance()+GrPorfit();
   double Set=GlobalVariableGet("multi")-GlobalVariableGet("disable");
   double Sredstwa =GlobalVariableGet("sredstva");
   double lott=MarketInfo(Symbol(),MODE_MARGINREQUIRED)/1000;
   double Marga=AccountFreeMargin();
   double Balans=AccountBalance();
   double LotMin=MarketInfo(Symbol(),MODE_MINLOT);
   double LotMax=MarketInfo(Symbol(),MODE_MAXLOT);
   double StepLot=MarketInfo(Symbol(),MODE_LOTSTEP);
   double StopLv=AccountStopoutLevel();
   int PrsMinLot=1000*LotMin;
   if(Sredstwa==0){Sredstwa=Marga;GlobalVariableSet("sredstva",Marga);}
   if(GlobalVariableGet("multi")>1){Risk=GlobalVariableGet("Risc");}
   if(Risk<0)Risk=0;
   if(Risk>100)Risk=100; 
   if(StepLot==0.01){int step=2;}else{step=1;}  
   if(Set<1){Set=1;}
//---------------------------     
   //Print(AccountFreeMargin(),"  ",Sredstwa);
   Zalog=(Marga*(Risk/100))/Set;
   LotOpt=NormalizeDouble((Zalog/1000),step);
   if(LotOpt>LotMax)LotOpt=LotMax;
   if(LotOpt<LotMin)LotOpt=LotMin;
   //if(Marga<Sredstva/2){return(0);}
   return(LotOpt);
} 
//-----------------------------------------------------------------------------+
//                                                              |
//-----------------------------------------------------------------------------+
double NullDot(){double prise=0;int count=0,countlot=0;
if(OrdersTotal()<1){return(Bid);}
double MinLot=MarketInfo(Symbol(),MODE_MINLOT);
for(int i=0;i<OrdersTotal();i++){
  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
    if(OrderSymbol()==Symbol()){
      countlot=(OrderLots()/MinLot);
      count=count+countlot;
      prise=prise+(OrderOpenPrice()*countlot);
    }
  }
}
prise=prise/count;
return(prise);
} 
//-----------------------------------------------------------------------------+
//                                                              |
//-----------------------------------------------------------------------------+
double NullDotBuy(){double prise=0;int count=0,countlot=0;
if(CountOpOrd("0",0)<1){return(Bid);}
double MinLot=MarketInfo(Symbol(),MODE_MINLOT);
for(int i=0;i<OrdersTotal();i++){
  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
    if(OrderSymbol()==Symbol()){
      if(OrderType()==0){
        countlot=(OrderLots()/MinLot);
        count=count+countlot;
        prise=prise+(OrderOpenPrice()*countlot);
      }  
    }
  }
}
prise=prise/count;
return(prise);
}
//-----------------------------------------------------------------------------+
//                                                              |
//-----------------------------------------------------------------------------+
double NullDotSell(){double prise=0;int count=0,countlot=0;
if(CountOpOrd("0",1)<1){return(Bid);}
double MinLot=MarketInfo(Symbol(),MODE_MINLOT);
for(int i=0;i<OrdersTotal();i++){
  if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
    if(OrderSymbol()==Symbol()){
      if(OrderType()==1){
        countlot=(OrderLots()/MinLot);
        count=count+countlot;
        prise=prise+(OrderOpenPrice()*countlot);
      }  
    }
  }
}
prise=prise/count;
return(prise);
}
//+------------------------------------------------------------------+
//|                                                  |
//+------------------------------------------------------------------+
void SetArrow(string nm,int kod,int razm,int bar,double prs,color col){
//if(!DriveArrow)return;
string Name=StringConcatenate(nm,TimeToStr(TimeLocal(),TIME_DATE|TIME_SECONDS));
ObjectCreate(Name,OBJ_ARROW,0,0,0,0,0,0,0);
ObjectSet(Name,OBJPROP_ARROWCODE,kod);
ObjectSet(Name,OBJPROP_STYLE,DRAW_ARROW);
ObjectSet(Name,OBJPROP_TIME1,Time[bar]);
ObjectSet(Name,OBJPROP_PRICE1,prs);
ObjectSet(Name,OBJPROP_WIDTH,razm);
ObjectSet(Name,OBJPROP_COLOR,col);
return;}
//-----------------------------------------------------------------------------+
//                           |
//-----------------------------------------------------------------------------+
string MutiDet(){
  double set =GlobalVariableGet("multi")-GlobalVariableGet("disable");
  string mode=StringConcatenate("MULTI CHART MODE \n",DoubleToStr(set,0)," EXPERT ENABLES");
  string mode2="SINGLE CHART MODE";
  if(GlobalVariableGet("multi")<2){return(mode2);}
  if(GlobalVariableGet("multi")>1){return(mode);}                                         
}
//-----------------------------------------------------------------------------+
//                                                     |
//-----------------------------------------------------------------------------+
void Info(){
static int maxord;
if(maxord<CountOpOrd("0")){maxord=CountOpOrd("0");} 
Comment(
        "ACCOUNT BALANSE                                 ="+(DoubleToStr(AccountBalance()+PorfitBuySell(0)+PorfitBuySell(1),1))+"$\n"+
        "ACCOUNT FREE MARGIN                         ="+(DoubleToStr(AccountFreeMargin(),1))+"$\n"+
        "CURRENT PROFIT                                    ="+(DoubleToStr(GrPorfit(),1))+"$\n"+
        "PROFIT FROM THE START OF TRADING  ="+(DoubleToStr(AccountBalance()-StartDepo,1))+"$\n"+
        "ALOVED ORDERS FOR THE OPENING      ="+MaxOrd_1+"Pc.\n"+
        "OPEN ORDERS                                         ="+CountOpOrd("0")+"Pc.\n"+
        gTime,"\n", 
        MutiDet(),"\n",
        "Risk = ",GlobalVariableGet("Risc")," %\n",
        maxord
        );     
return;
}
//-----------------------------------------------------------------------------+
//                                              |
//-----------------------------------------------------------------------------+
bool Varning(){int ord;double depo,rick;
double Set2=GlobalVariableGet("multi")-GlobalVariableGet("disable");
if(Set2<1){Set2=1;}
  if(MaxOrd_1<15){
      depo=MarketInfo(Symbol(),MODE_MARGINREQUIRED)*CalcLotsAuto()*30;
      ord=AccountBalance()/(MarketInfo(Symbol(),MODE_MARGINREQUIRED)*CalcLotsAuto()*2);
      rick=NormalizeDouble((AccountBalance()/Set2/15/MarketInfo(Symbol(),MODE_MARGINREQUIRED)*10),1);
        Alert("THERE IS NOT ENOUGH MEANS FOR THE ACCOUNT"+"\n"+
        "For such quantity of warrants it is necessary"+"\n"+
        "The starting Deposit ="+depo+" $\n"+
        "On your means it is possible to open "+ord+" Orders"+"\n"+
        "Fill up your account please"+"\n"+
        "Or reduce quantity of warrants"+"\n"+
        "Or reduce the Risk of lower ="+DoubleToStr(rick,2)+" % \n"+
        "Or disconnect the alarm system");
    return(true);
  }
return(false);
}
//-----------------------------------------------------------------------------+
//                                               |
//-----------------------------------------------------------------------------+
bool TradeTime(){
int StartTradeHour=StartTrade;
int EndTradeHour=EndTrade;
if(!TradeOfTime){
gTime=StringConcatenate("the end of trading on Friday in ",DoubleToStr(EndTradeHour,0),":00 am");
if(DayOfWeek()==5){if(TimeHour(TimeCurrent())>EndTradeHour){return(false);}}
if(DayOfWeek()==1){if(TimeHour(TimeCurrent())<2){return(false);}}
if(DayOfWeek()==6||DayOfWeek()==0){return(false);}
return(true);}
if(DayOfWeek()==5){StartTradeHour=0;if(TimeHour(TimeCurrent())>EndTradeHour){return(false);}}else{StartTradeHour=StartTrade;}
if(DayOfWeek()==1){if(TimeHour(TimeCurrent())<2){gTime="Start tarde in  01:00 am";return(false);}}
if(DayOfWeek()==6||DayOfWeek()==0){return(false);}
if(StartTradeHour<EndTradeHour){
  if(TimeHour(TimeCurrent())>=StartTradeHour&&TimeHour(TimeCurrent())<EndTradeHour
    ||(CountOpOrd("0")+CountOpOrd("1"))){
    gTime=StringConcatenate("By the end of trading session :",DoubleToStr((EndTradeHour-TimeHour(TimeCurrent())),0)," hours");
    return(true);}}
if(StartTradeHour>EndTradeHour){
  if(TimeHour(TimeCurrent())>=StartTradeHour||TimeHour(TimeCurrent())<EndTradeHour
    ||(CountOpOrd("0")+CountOpOrd("1"))){
    gTime=StringConcatenate("By the end of trading session :",DoubleToStr((EndTradeHour-TimeHour(TimeCurrent())),0)," hours");
    return(true);}}    
gTime=StringConcatenate("resting to : ",StartTradeHour,": 00");    
return(false);
}
//+------------------------------------------------------------------+
//|                                                      |
//+------------------------------------------------------------------+
bool EcvitiTral3(double EqStep){static double EqvTralStep=0.01;
if(OrdersTotal()<1){gEqviti=AccountBalance();if(FullAuto){EqvTralStep=CalcLotsAuto();}else{EqvTralStep=EqStep;}return(false);}
int multy=GlobalVariableGet("multi")-GlobalVariableGet("disable");
if(FullAuto){
 if(EqvTralStep<OrdersLot()*multy){EqvTralStep=OrdersLot()*multy;}
}else{if(EqvTralStep<EqStep*multy){EqvTralStep=EqStep*multy;}}


    if(AccountEquity()>AccountBalance()){if(gEqviti<AccountBalance()){gEqviti=AccountBalance();}
      if(AccountEquity()-AccountBalance()>((AccountBalance()/100)*((EqvTralStep*2)+EqvTralStep))){EqvTralStep=EqvTralStep*2;eqvtrade=true;}
      if(AccountEquity()>(gEqviti+(gEqviti/100*EqvTralStep))){
        gEqviti=gEqviti+(gEqviti/200*EqvTralStep);  
          
        if(!GlobalVariableCheck("stop")){GlobalVariableSet("stop",0);}
      }
      if(AccountEquity()<=gEqviti){CloseAll();GlobalVariableDel("stop");return(false);}
      else{
        if(gEqviti<AccountBalance()){gEqviti=AccountBalance();}
        Comment(
                 "EQUITY TRALING MODE \n",
                 "EQUITY TRALING STEP   =",EqvTralStep," %",
                 "\nACCOUNT BALANS         = ",AccountBalance(),
                 "\nCLOSE LEVEL                  = ",gEqviti,
                 "\nACCOUNT EQUITY        = ",AccountEquity(),
                 "\nNEXT STEP                     = ",gEqviti+(gEqviti/100*EqvTralStep));
                 return(true);
      }
    }else{GlobalVariableDel("stop");if(FullAuto){EqvTralStep=CalcLotsAuto();}else{EqvTralStep=EqStep;}}  
  
return(false);
} 
//+------------------------------------------------------------------+
//|            |
//+------------------------------------------------------------------+
bool IfOrder(string Sy="",int Typ=-1,int Magik=-1){
if(Sy=="0"){Sy=Symbol();}
  if(OrderSymbol()==Sy||Sy==""){
    if(OrderType()==Typ||Typ==(-1)){
      if(OrderMagicNumber()==Magik||Magik==(-1)){
        return(true);
      }
    }
  }
 return(false); 
}
//+------------------------------------------------------------------+
//|             |
//+------------------------------------------------------------------+
int CountOpOrd(string Sy="",int Typ=-1,int Magik=-1){int count=0;
if(Sy=="0"){Sy=Symbol();}
  for(int i=0;i<OrdersTotal();i++){
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
      if(OrderSymbol()==Sy||Sy==""){
        if(OrderType()==Typ||Typ==(-1)){
          if(OrderMagicNumber()==Magik||Magik==(-1)){
            if(OrderCloseTime()==0){
              count++;
            }  
          }
        }
      }
    }
  }
 return(count);  
}
//+----------------------------------------------------------------------------+
//                   +
//-----------------------------------------------------------------------------+
double PorfitBuySell(int tip){double grpr=-1;
if(OrdersTotal()<1){return(-1);}
   for(int n=OrdersTotal()+1;n>=0;n--){
     if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){  
       if(IfOrder("0",tip)){grpr=grpr+OrderProfit()+OrderSwap()+OrderCommission();}
     }    
   } 
return(grpr);
}
//+----------------------------------------------------------------------------+
//                   +
//-----------------------------------------------------------------------------+
double GlobalProfitBuySell(int tip){double grpr=0;
if(OrdersTotal()<1){return(-1);}
   for(int n=OrdersTotal()+1;n>=0;n--){
     if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){  
       grpr=grpr+OrderProfit()+OrderSwap()+OrderCommission();
     }    
   } 
return(grpr);
}
//+----------------------------------------------------------------------------+
//                                        +
//-----------------------------------------------------------------------------+
void CloseAll(){
 while(OrdersTotal()>0){
   double profit=1000000;
   for(int n=OrdersTotal()+1;n>=0;n--){
     if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){  
       if(OrderProfit()<profit){
         profit=OrderProfit();
       }
     }    
   } 
  del(OrderTicket()); 
 }
return;    
}
//+----------------------------------------------------------------------------+
//                                           +  
//-----------------------------------------------------------------------------+
bool TimeOfTrade(){int count=0,typ,hc=0;double OpPrs=0,distanse=0,shir;
if(OrdersTotal()<1)return(true);
if(Bid==NullDot())return(true);
if(GlobalVariableCheck("pause")){int pause=GlobalVariableGet("pause");}
else{pause=MinTradePause;GlobalVariableSet("pause",MinTradePause);}
  for(int n=0;n<OrdersTotal();n++){
    if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){  
      if(OrderSymbol()==Symbol()){
        if(OrderOpenTime()>count){count=OrderOpenTime();OpPrs=OrderOpenPrice();typ=OrderType();}
      }
    }    
  } 
if(CountOpOrd("0")<1){
  if(OrderSelect(OrdersHistoryTotal()-1,SELECT_BY_POS,MODE_HISTORY)){
    if(TimeCurrent()-OrderCloseTime()>Volume[1]){
      return(true);
    }else{return(false);}  
  }
}   
if((MathAbs(OpPrs-Bid)/Point)<10){return(false);}
if(OpPrs!=0){distanse=(MathAbs(OpPrs-Bid)/Point)/(10*(Bid/Digits));}  
if((TimeCurrent()-count)>((MinTradePause*60)*(distanse+1))){return(true);}
return(false);
}
//+----------------------------------------------------------------------------+
//                                               +
//-----------------------------------------------------------------------------+
void MultyClose(){
double profit[50][2],loss[50][2],prom[50][2];int cl[50];
int i, n, prindex, lsindex, countprofit,countloss,countord;
if(OrdersTotal()<2){return;}
  for(n=0;n<OrdersTotal();n++){
    if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){  
      if(OrderProfit()>0){profit[countprofit][0]=OrderProfit();profit[countprofit][1]=OrderTicket();countprofit++;}
      if(OrderProfit()<0){loss[countloss][0]=OrderProfit();loss[countloss][1]=OrderTicket();countloss++;}
    }
  }
  bool close=false;
//--        
  ArrayResize(profit,countprofit);
  ArrayResize(prom,countprofit);
  for(n=0;n<countprofit;n++){
  int index=ArrayMaximum(profit,WHOLE_ARRAY,0);
  prom[n][0]=profit[index][0];
  prom[n][1]=profit[index][1];
  profit[index][0]=0;
  profit[index][1]=0;
  }
  for(n=0;n<countprofit;n++){
  profit[n][0]=prom[n][0];
  profit[n][1]=prom[n][1];  
  }
//--       
  index=0;
  ArrayResize(prom,countloss);
  ArrayResize(loss,countloss);
  ArrayInitialize(prom,0.0);
  for(n=0;n<countloss;n++){
  index=ArrayMinimum(loss,WHOLE_ARRAY,0);
  prom[n][0]=loss[index][0];
  prom[n][1]=loss[index][1];
  loss[index][0]=0;
  loss[index][1]=0;
  }
  for(n=0;n<countloss;n++){
  loss[n][0]=prom[n][0];
  loss[n][1]=prom[n][1]; 
  }  
//--------------------------------------------  
  double pr=0,ls=0;
  for(n=0;n<countprofit;n++){
    pr=pr+profit[n][0];
    prindex++;
    ls=0;
    lsindex=0;
    for(i=0;i<countloss;i++){
      ls=ls+loss[i][0];
      lsindex++;
      if(pr>0){  
        if(pr-MathAbs(ls)>=MinPips){
          close=true;
          break;
        }
      }  
    }
  }
  if(lsindex==0||prindex==0)return;
  if(!close)return;
    for(n=0;n<prindex;n++){
      cl[n]=profit[n][1];
      del(cl[n]);
    }
    for(n=0;n<lsindex;n++){
      cl[n]=loss[n][1];
      del(cl[n]);
    }     
  return;
  }
//+----------------------------------------------------------------------------+
//                                                   +
//-----------------------------------------------------------------------------+
void CloseBy(){
double profit1=0, profit2=0;double buy[50][2],sell[50][2];
int i, n, tip, tip2 ,ticket1=0, ticket2=0,countbuy,countsell;
if(OrdersTotal()<2){return;}
  for(n=0;n<OrdersTotal();n++){
    if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){  
      if(OrderType()<1){buy[countbuy][0]=OrderProfit();buy[countbuy][1]=OrderTicket();countbuy++;}
      if(OrderType()>0){sell[countsell][0]=OrderProfit();sell[countsell][1]=OrderTicket();countsell++;}
    }
  }
  //int profitbuy,profitsell;
  ArrayResize(buy,countbuy);  
  ArrayResize(sell,countsell); 
  for(n=0;n<countbuy;n++){ 
    int profitbuy=buy[n][0];
    int ticketbuy=buy[n][1];
    for(i=0;i<countsell;i++){
      int profitsell=sell[i][0];
      int ticketsell=sell[i][1];
      if(profitbuy==profitsell&&profitbuy>0){
        del(ticketbuy);
        del(ticketsell);
        return;
      }
    }
  }       
}
//+----------------------------------------------------------------------------+
//                                                    +
//+----------------------------------------------------------------------------+ 
void DelLoss(){
if(CountOpOrd("0")<2){return;}
double loss=0,profit=0,GrProfit=0;int n,x,y,ticket=0,count=0,losskount=0;
int Ticket[50];
int lossticket[50][2];
//ArrayInitialize(Ticket,0);
   for(n=0;n<OrdersTotal();n++){
     if(OrderSelect(n,SELECT_BY_POS,MODE_TRADES)){  
       if(OrderSymbol()==Symbol()){
         if(OrderProfit()>0){
           profit=profit+OrderProfit();
           Ticket[count]=OrderTicket();
           count++;
         }
         else{
           if(OrderProfit()<loss){
             loss=OrderProfit();
             lossticket[losskount][0]=OrderTicket();
             lossticket[losskount][1]=OrderProfit();
             losskount++;         
           }
         }  
       }  
     }    
   }
   ArrayResize(lossticket,losskount);
   ArrayResize(Ticket,count);
   for(n=losskount-1;n>=0;n--){
     if(profit<=0){return;}
     if(loss==0){return;}
     if(profit+lossticket[n][1]>=(MinPips/CalcLotsAuto()/10)){    
       for(y=0;y<count+1;y++){
         if(OrderSelect(Ticket[y],SELECT_BY_TICKET)){
           if(OrderCloseTime()==0){
             del(OrderTicket());
           }
         }
       }     
       if(OrderSelect(lossticket[n][0],SELECT_BY_TICKET)){
         if(OrderCloseTime()==0){
           del(lossticket[n][0]);
           return(true);
         }
       }
     }
   }
return;   
}
//-----------------------------------------------------------------------------+
//                                                    |
//-----------------------------------------------------------------------------+
bool NevBar(){
   static int PrevTime=0;
   if (PrevTime==Time[0]) return(false);
   PrevTime=Time[0];
   return(true);} 
//-----------------------------------------------------------------------------+
//                                      |
//+----------------------------------------------------------------------------+
void del(int ticket){int err;
 for(int i=0;i<1;i++){
   GetLastError();// 
   OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES);
   string symbol = OrderSymbol();
   if(OrderType()==OP_BUY){RefreshRates();
     double prise = MarketInfo(symbol,MODE_BID);
     if(!OrderClose(ticket,OrderLots(),prise,3,Green)){err = GetLastError();}}
   if(OrderType()==OP_SELL){RefreshRates();
     prise = MarketInfo(symbol,MODE_ASK);
     if(!OrderClose(ticket,OrderLots(),prise,3,Green)){err = GetLastError();}}
 if(err == 0){PlaySound("expert.wav");break;} 
 if(err != 0){PlaySound("timeout.wav");Print("Error for Close Funtion =",err);} 
 while(!IsTradeAllowed()){Sleep(5000);}//      5  
 if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
 } 
}
//-----------------------------------------------------------------------------+
//__________________________________________________________|
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  //Comment(m);
  if (StringLen(m)>0) Print(m);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    ex -                                                       |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, datetime ex=0) {
  bool   fm;
  color  cl=White;
  double op, pa, pb, os, ot;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;

  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);
  //if(OrderType()==0||OrderType()==2||OrderType()==4){if(Ask-stoplevel<sl||Bid+stoplevel>tp){return;}}
  //if(OrderType()==1||OrderType()==3||OrderType()==5){if(Bid+stoplevel>sl||Ask-stoplevel<tp){return;}}
  //if(MathAbs(sl-Ask)<stoplevel||MathAbs(tp-Ask)<stoplevel){return;}
  if(pp==op&&sl==os&&tp==ot){return;}
  if ((sl==os&&(os!=0||sl!=0))&& (tp==ot&&(ot!=0||tp!=0))) {return;}
    for (it=1; it<=NumberOfTry; it++) {
      //if ((!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      fm=OrderModify(OrderTicket(), pp, sl, tp, ex, cl);
      if (fm) {
        if (UseSound) PlaySound(NameFileSound); break;
      } else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);
        if(print){Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
                  Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
                        "  op="+GetNameOP(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);}
        Sleep(1000*10);
        //if(er==130){del(OrderTicket());}
      }
    }
  //}
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 06.03.2008                                                     |
//|   :                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                  |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )           |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              if (ot<=OrderOpenTime()) return(True);
            }
          }
        }
      }
    }
  }
  return(False);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("BuyLimit");
    case OP_SELLLIMIT: return("SellLimit");
    case OP_BUYSTOP  : return("BuyStop");
    case OP_SELLSTOP : return("SellStop");
    default          : return("Unknown Operation");
  }
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 10.04.2008                                                     |
//|   :     .                            |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
void OpenPosition(string sy, int op, double ll, double Sl=0, double Tp=0, int mn=0) {
  color    clOpen;
  datetime ot;
  double   pp, pa, pb, tp ,sl;
  int      dg, err, it, ticket=0;
  string   lsComm="";
  

  
  if (sy=="" || sy=="0") sy=Symbol();
  int stoplevel=MarketInfo(sy,MODE_STOPLEVEL);
  int spread=MarketInfo(sy,MODE_SPREAD);
  if(Tp!=0&&Tp<stoplevel+spread){Tp=stoplevel;}  
  if (op<1){
   if (Sl>0) {sl=MarketInfo(Symbol(),MODE_ASK)-Sl*Point; }else {sl=0;}
   if (Tp>0) {tp=MarketInfo(Symbol(),MODE_ASK)+Tp*Point; }else{ tp=0;}
  }else{
   if (Sl>0) {sl=MarketInfo(Symbol(),MODE_BID)+Sl*Point; }else{ sl=0;}
   if (Tp>0) {tp=MarketInfo(Symbol(),MODE_BID)-Tp*Point;} else {tp=0;}}  
   
  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  for (it=1; it<=NumberOfTry; it++) {
    if (IsStopped()) {
      Print("OpenPosition():   ");
      break;}
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    dg=MarketInfo(sy, MODE_DIGITS);
    pa=MarketInfo(sy, MODE_ASK);
    pb=MarketInfo(sy, MODE_BID);
    if (op==OP_BUY) pp=pa; else pp=pb;
    pp=NormalizeDouble(pp, dg);
    ot=TimeCurrent();
    if (MarketWatch)
      ticket=OrderSend(sy, op, ll, pp, Slippage, 0, 0, lsComm, mn, 0, clOpen);
    else
      ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, lsComm, mn, 0, clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(NameFileSound); break;
    } else {
      err=GetLastError();
      if (pa==0 && pb==0) Message("      "+sy);
      //    
      if(print){
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa," Bid=",pb," sy=",sy," ll=",ll," op=",GetNameOP(op),
            " pp=",pp," sl=",sl," tp=",tp," mn=",mn);}
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66.666);
        if (ExistPositions(sy, op, mn, ot)) {
          if (UseSound) PlaySound(NameFileSound); break;
        }
      }
      if (err==140 || err==148 || err==4110 || err==4111) break;
      if (err==141) Sleep(1000*100);
      if (err==145) Sleep(1000*17);
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      if (err!=135) Sleep(1000*7.7);
    }
  }
  if (MarketWatch && ticket>0 && (sl>0 || tp>0)) {
    if (OrderSelect(ticket, SELECT_BY_TICKET)) ModifyOrder(-1, sl, tp);
  }
}
//+----------------------------------------------------------------------------+

